<?php defined('SYSPATH') OR die('No direct access allowed.');
/**
 * Array helper class.
 *
 * $Id: arr.php 4346 2009-05-11 17:08:15Z zombor $
 *
 * @package    Core
 * @author     Kohana Team
 * @copyright  (c) 2007-2008 Kohana Team
 * @license    http://kohanaphp.com/license.html
 */
class common_Core {

	/**
	 * Return a callback array from a string, eg: limit[10,20] would become
	 * array('limit', array('10', '20'))
	 *
	 * @param   string  callback string
	 * @return  array
	 */
	  public function __construct()
	 {
		
		parent::__construct();
		//include Kohana::find_file('../modules/indox/models','inbox_data',TRUE,'php');
		$this->data=new Inbox_Data_Model();
        	//$this->session=Session::instance();
		//$this->user_id=$this->session->get('userid');
		//Nauth::is_login('',$this->docroot);
		 //$this->docroot= $this->docroot;

	 }
	 
	 //Get the time 
	public static  function getdatediff($dt){
	     //echo common::get_time_difference($dt, time());
	     //exit;
            if( $diff=common::get_time_difference($dt, time()) ) // <-- HERE!
            {
              if($diff["days"] > 0){
                return $diff["days"] . " days ago ";
              }
              else{
                if($diff["hours"]>0){
                    if($diff["hours"] > 10){
                        return $diff["hours"]." hours ago ";
                    }else{
                        return $diff["hours"]." hours ".$diff["minutes"]. " minutes ago";
                    }
                }
                else{
                    if($diff["minutes"]==0){
                        return " just now ";
                    }else{
                        return $diff["minutes"]." minutes ago ";
                    }
                }
              }
            }

        }
        
        public static function get_time_difference( $start, $end )
{
            $uts['start']      =    strtotime( $start );
            $uts['end']        =    $end ;
            if( $uts['start']!==-1 && $uts['end']!==-1 )
            {
                if( $uts['end'] >= $uts['start'] )
                {
                    $diff    =    $uts['end'] - $uts['start'];
                    if( $days=intval((floor($diff/86400))) )
                        $diff = $diff % 86400;
                    if( $hours=intval((floor($diff/3600))) )
                        $diff = $diff % 3600;
                    if( $minutes=intval((floor($diff/60))) )
                        $diff = $diff % 60;
                    $diff    =    intval( $diff );           
                    return( array('days'=>$days, 'hours'=>$hours, 'minutes'=>$minutes, 'seconds'=>$diff) );
                }
                else
                {
                   // trigger_error( "Ending date/time is earlier than the start date/time", E_USER_WARNING );
			
		   return "Just Now";
                }
            }
            else
                 {
                trigger_error( "Invalid date/time data detected", E_USER_WARNING );
            }
            return( false );
        }
                
    public function change_time($time) {
        $time = strtotime($time);
        $c_time = time() - $time;
        if ($c_time < 60) {
            return '0 minute ago.';
        } else if ($c_time < 120) {
            return '1 minute ago.';
        } else if ($c_time < (45 * 60)) {
            return floor($c_time / 60) . ' minutes ago.';
        } else if ($c_time < (90 * 60)) {
            return '1 hour ago.';
        } else if ($c_time < (24 * 60 * 60)) {
            return floor($c_time / 3600) . ' hours ago.';
        } else if ($c_time < (48 * 60 * 60)) {
            return '1 day ago.';
        } else {
            return floor($c_time / 86400) . ' days ago.';
        }
    }
    
    public function check_privacy($user_id='')
    {
    $this->pvy = $this->model->get_privacy($user_id);
    return $this->pvy["mysql_fetch_array"]->updates;
        
    }


   public function insert_mail($userid = "", $toid = "", $subject = "",$msg_body = "",$objecttype=-1)
    {
	 $this->data=new Inbox_Data_Model();
   	 $mailid = $this->data->insert_mail($userid,$subject,$msg_body,$objecttype);
	 $this->data->sent_mail($userid,$mailid,$toid);	
	 return 1;
   // return $this->pvy["mysql_fetch_array"]->updates;
        
    }
        public function get_video($video_id='')
    {
        $this->video_mod = new Video_Model();
    $this->video_image = $this->video_mod->get_video($video_id);
            if(count($this->video_image))
            {
            return $this->video_image["mysql_fetch_array"]->thumb_url;
            }
            else
            {
            return 0;
            }
        
    } 
     public function delete_update($typeid = '', $actionid = '' , $post_id = '' )
    {
    		$this->model=new update_model_Model();
    		$this->delete_updates = $this->model->delete_upd($typeid,$actionid,$post_id);
    } 
         public function get_album_photo($album_id = '')
    {
		 $this->model_photo=new Photos_Model();
    		 $this->photos = $this->model_photo->get_abmphoto($album_id);
    		 return $this->photos;
    }
    
                
} 


// End Common
