<?php defined('SYSPATH') or die('No direct script access.');

//create the model class
class Sawaal_Model extends Model
 {
     	public function __construct()
	{
		parent::__construct();
		
		$this->db=new Database();
		//prefix table
		 include Kohana::find_file('../application/config','database',TRUE,'php');
		 $this->config = $config ['default'];
		 $this->prefix = $this->config['table_prefix'];
		 $this->usertable = $config['usertable'];
   	}
	//add sms question
	public function add_sms_question($mobile_no='',$content='')
	{
	
		$result=$this->db->query("insert into ".$this->prefix."question(question,question_description,user_id,type,category,time,mobile_no,status)values('$content','SMS Question', '-1','-1','26',SYSDATE(),'$mobile_no','0')");
			
		return $result;		
		
			
	}

	//show the best answers
	public function best_solution($offset='',$pageno='',$noofpage='')
	{
	
		$result=$this->db->query("select *,".$this->prefix.$this->usertable.".name as username,".$this->prefix."question.id as question_id,time as cdate from ".$this->prefix."question left join ".$this->prefix."answers_category on ".$this->prefix."question.category=".$this->prefix."answers_category.category_id left join ".$this->prefix.$this->usertable." on ".$this->prefix."question.user_id=".$this->prefix.$this->usertable.".id left join ".$this->prefix."users_profile on ".$this->prefix.$this->usertable.".id=".$this->prefix."users_profile.user_id where ".$this->prefix."question.status=0 AND ".$this->prefix."question.category!=-1 group by ".$this->prefix."question.id desc having ".$this->prefix."question.best_answer>0 limit 0,4");
		return $result;
	}

	//get unasnwered questions
	public function get_unanswered_questions()
	{
			$result=$this->db->query("select *,".$this->prefix.$this->usertable.".name as username,".$this->prefix."question.id as question_id,time as cdate from ".$this->prefix."question left join ".$this->prefix.$this->usertable." on ".$this->prefix."question.user_id=".$this->prefix.$this->usertable.".id left join ".$this->prefix."users_profile on ".$this->prefix.$this->usertable.".id= ".$this->prefix."users_profile.user_id left join ".$this->prefix."answers_category on ".$this->prefix."question.category=".$this->prefix."answers_category.category_id where ".$this->prefix."question.status=0 AND ".$this->prefix."question.category!=-1 AND ".$this->prefix."question.answer=0 group by ".$this->prefix."question.id desc limit 0,5");
			return $result;

	}

	//get the online questions
	public function get_online_questions()
	{
			$result=$this->db->query("select *,".$this->prefix.$this->usertable.".name as username,".$this->prefix."question.id as question_id,time as cdate from ".$this->prefix."question left join ".$this->prefix.$this->usertable." on ".$this->prefix."question.user_id=".$this->prefix.$this->usertable.".id left join ".$this->prefix."users_profile on ".$this->prefix.$this->usertable.".id= ".$this->prefix."users_profile.user_id left join ".$this->prefix."answers_category on ".$this->prefix."question.category=".$this->prefix."answers_category.category_id where ".$this->prefix."question.status=0 AND type !=-1 AND ".$this->prefix."question.category!=-1 group by ".$this->prefix."question.id desc limit 0,3");
			return $result;

	}
	//get the sms questions
	public function get_sms_questions()
	{
			$result=$this->db->query("select *,".$this->prefix.$this->usertable.".name as username,".$this->prefix."question.id as question_id,time as cdate from ".$this->prefix."question left join ".$this->prefix.$this->usertable." on ".$this->prefix."question.user_id=".$this->prefix.$this->usertable.".id left join ".$this->prefix."users_profile on ".$this->prefix.$this->usertable.".id= ".$this->prefix."users_profile.user_id left join ".$this->prefix."answers_category on ".$this->prefix."question.category=".$this->prefix."answers_category.category_id where ".$this->prefix."question.status=0 AND answer!=0  AND ".$this->prefix."question.category!=-1 order by ".$this->prefix."question.answer desc limit 0,4");
			return $result;

	}

	//get the recent questions
	public function get_question($offset='',$pageno='',$noofpage='')
	{
	
		$result=$this->db->query("select *,".$this->prefix.$this->usertable.".name as username,".$this->prefix."question.id as question_id,time as cdate from ".$this->prefix."question left join ".$this->prefix.$this->usertable." on ".$this->prefix."question.user_id=".$this->prefix.$this->usertable.".id left join ".$this->prefix."users_profile on ".$this->prefix.$this->usertable.".id= ".$this->prefix."users_profile.user_id left join ".$this->prefix."answers_category on ".$this->prefix."question.category=".$this->prefix."answers_category.category_id where ".$this->prefix."question.status=0 AND type=-1 AND ".$this->prefix."question.category!=-1 group by ".$this->prefix."question.id desc limit $offset,$noofpage ");
		return $result;
	}

	//count the recent questions
	public function get_recent_count()
	{
		$result=$this->db->query("select *,".$this->prefix.$this->usertable.".name as username,".$this->prefix."question.id as question_id,time as cdate from ".$this->prefix."question left join ".$this->prefix.$this->usertable." on ".$this->prefix."question.user_id=".$this->prefix.$this->usertable.".id left join ".$this->prefix."users_profile on ".$this->prefix.$this->usertable.".id= ".$this->prefix."users_profile.user_id left join ".$this->prefix."answers_category on ".$this->prefix."question.category=".$this->prefix."answers_category.category_id where ".$this->prefix."question.status=0 AND type=-1 group by ".$this->prefix."question.id desc");
		$recent_count=count($result);
		return $recent_count;
	}
   
  
}
