<?php defined('SYSPATH') or die('No direct script access.');  
class Facebook_Controller extends website_Controller 
{	
	const ALLOW_PRODUCTION = FALSE;
	public $template = 'template/template';
	public function __construct()
	{
		parent::__construct();		
		$this->session = Session::instance();	
		$this->userid = $this->session->get("userid");
		$this->facebook_session_key = $this->session->get("facebook_offline_session_key");
		
		
		$api = Kohana::config('api.facebook');
		$this->apikey = $api["app_key"];
		$this->secretkey = $api["app_secret"];
		
		$this->user = new Users_Model();
		require_once(APPPATH.'vendor/facebook/facebook.php');
		$this->facebook = new Facebook($this->apikey, $this->secretkey);
	}
	
	/** FACEBOOK CONNECT **/
	
	public function connect()
	{
		if(!$this->facebook_session_key){
			if($this->input->get("auth_token")){
				url::redirect("http://facebook.com/authorize.php?api_key=".$this->apikey."&v=1.0&ext_perm=publish_stream&next=http://".$_SERVER['HTTP_HOST']."/facebook/read");
			}
			$user_data = $this->facebook->require_login();
		}
		else{
			?>
			<script>
				window.close();
			</script>		 
			<?php
			exit;	
		}	
		$this->template->title = "Facebook Connect"; 
	}
	
	/** READ STREAM **/
	
	public function read()
	{
		url::redirect("http://facebook.com/authorize.php?api_key=".$this->apikey."&v=1.0&ext_perm=read_stream&next=http://".$_SERVER['HTTP_HOST']."/facebook/skey");	
	}
	
	public function skey()
	{
		url::redirect("http://www.facebook.com/login.php?api_key=".$this->apikey."&v=1.0&next=http://".$_SERVER['HTTP_HOST']."/facebook/rskey&cancel_url=http://www.facebook.com/connect/login_failure.html&fbconnect=true&return_session=true&session_key_only=true");      
	}
	
	
	public function rskey()
	{
		$session_val = $this->input->get("session");
		$authData = json_decode($session_val,true);
		$user_details = $this->facebook->api_client->users_getInfo($authData["uid"], 'first_name,last_name,pic_square');
		
		//echo kohana::debug($user_details); exit;
		/* STORE AUTHENDICATION TOKEN TO DB */
		
		$first_name = htmlspecialchars($user_details[0]["first_name"]);
		$last_name = htmlspecialchars($user_details[0]["last_name"]);
		$image_url = htmlspecialchars($user_details[0]["pic_square"]);
			
		
			$status = $this->user->store_facebook_token($authData['sig'], $authData['secret'], $authData["uid"] , $first_name ,$last_name , $image_url , $authData["session_key"]);
			
			if($status == '1')
			{
			        Nauth::setMessage(1,"Successfully logged In.Please update your full profile information. ");
			        url::redirect('/profile/updateprofile/');
			}
			else
			{
			        Nauth::setMessage(1,"Successfully logged In.");
			        url::redirect('/profile/');
			        
			}
		
	}
	//end

}
