<?php defined('SYSPATH') or die('No direct script access.');
/**
 * Default Kohana controller. This controller should NOT be used in production.
 * It is for demonstration purposes only!
 *
 * @package    Core
 * @author     Kohana Team
 * @copyright  (c) 2007-2008 Kohana Team
 * @license    http://kohanaphp.com/license.html
 */
 
class Page_Controller extends Website_Controller {

	// Disable this controller when Kohana is set to production mode.
	// See http://docs.kohanaphp.com/installation/deployment for more details.
	const ALLOW_PRODUCTION = FALSE;

	// Set the name of the template to use
	public $template = 'template/template';
   	public function __construct()
	{
		 parent::__construct();
		 $this->module="answers";
		 $this->sawaal=new Sawaal_Model();
	 }

	public function index()
	{   
		$session=Session::instance();
		$var = $session->get('userid');
		// In Kohana, all views are loaded and treated as objects.
		if($var){
			/*$this->template->content = new View('home_content');
			$this->template->title = Kohana::config("application.strings.hometitle");*/
			url::redirect("/user/profile/");
		}else{ 
			if($this->input->get('inbox')){
				
				$_SESSION['Inbox'] = '1';
			}
			echo "<h1>404 : Page Not Found!</h1>";
			exit;
			//url::redirect("/user/profile/");
		}
	}
	public function about(){
		$session=Session::instance();
		$var = $session->get('userid');
		// In Kohana, all views are loaded and treated as objects.
		if($this->input->get('inbox')){
			
			$_SESSION['Inbox'] = '1';
		}
		$this->template->content = new View('pages/about');
		$this->template->title = "About Sawaal.com";	
	}

	public function faq(){
		$session=Session::instance();
		$var = $session->get('userid');
		// In Kohana, all views are loaded and treated as objects.
		if($this->input->get('inbox')){
			
			$_SESSION['Inbox'] = '1';
		}
		$this->template->content = new View('pages/faq');
		$this->template->title = "Frequently Asked Questions";	
	}

	public function terms(){
		$session=Session::instance();
		$var = $session->get('userid');
		// In Kohana, all views are loaded and treated as objects.
		if($this->input->get('inbox')){
			
			$_SESSION['Inbox'] = '1';
		}
		$this->template->content = new View('pages/terms');
		$this->template->title = "Terms of Use";	
	}

	public function privacy(){
		$session=Session::instance();
		$var = $session->get('userid');
		// In Kohana, all views are loaded and treated as objects.
		if($this->input->get('inbox')){
			
			$_SESSION['Inbox'] = '1';
		}
		$this->template->content = new View('pages/privacy');
		$this->template->title = "Privacy Policy";	
	}
	
	public function contact(){
		$session=Session::instance();
		$var = $session->get('userid');
		// In Kohana, all views are loaded and treated as objects.
		if($this->input->get('inbox')){
			
			$_SESSION['Inbox'] = '1';
		}
		//echo "test";
		if($_POST){
			//print_r($_POST);
			$headers = "From: $_POST[txt_email]";
			@mail("admin@sawaal.com","Feedback from Sawaal.com : $_POST[txt_name]",$_POST["txt_feed"],$headers);
			$_SESSION["Msg"] = "Your message was sent, thank you!";
		}
		$this->template->content = new View('pages/contactus');
		$this->template->title = "Contact Us";	
	}

	public function __call($method, $arguments)
	{
		// Disable auto-rendering
		$this->auto_render = FALSE;

		// By defining a __call method, all pages routed to this controller
		// that result in 404 errors will be handled by this method, instead of
		// being displayed as "Page Not Found" errors.
					echo "<h1>404 : Page Not Found!</h1>";

		//echo 'This text is generated by __call. If you expected the index page, you need to use: welcome/index/'.substr(Router::$current_uri, 8);
	}
    
} // End Welcome Controller

