<?php defined('SYSPATH') or die('No direct script access.');
/**
 * Defines all database activity for Events
 *
 * @package    Core
 * @author     Madhi
 * @copyright  (c) 2010 Ndot.in
 */

class Admin_Events_Model extends Model
 {

     public function __construct()
	 {
		
        parent::__construct();
		$db=new Database();
		include Kohana::find_file('../application/config','database',TRUE,'php');
		$this->config = $config ['default'];
		$this->prefix = $this->config['table_prefix'];
		$this->usertable = $config['usertable'];
		
	}
	public function index()
	{
		if($this->userid != '' && $this->usertype == -1)
		{
			url::redirect($this->docroot.'admin/events');
		}
		else
		{
			url::redirect($this->docroot);
		}
	}
	//getting all events
	public function get_allevents($eid,$offset='',$range='')
	{
		$query = "select * from ".$this->prefix."events order by event_date desc limit $offset,$range";
		$result = $this->db->query($query);
		return $result;
	}

	public function get_editdata($eid)
	{
		if($eid)
		{
			$query = "select * from ".$this->prefix."events where event_id = '$eid' order by event_date desc";
			$result = $this->db->query($query);
			return $result;
		}
	}
	public function get_totalevents()
	{
		$query = "select * from ".$this->prefix."events order by event_date desc";
		$result = $this->db->query($query);
		return $result;
	}
	 
	 //create event
	 public function insert_event($title='',$place='',$description='',$date='',$stime='',$etime='',$address='',$contacts='',$userid='',$contact_email = '')
	{
		$title=html::specialchars($title);
		$place=html::specialchars($place);
		$description=html::specialchars($description);
		$address=html::specialchars($address);
		$contacts=html::specialchars($contacts);
		$contact_email=html::specialchars($contact_email);
		$select = "select * from ".$this->prefix."events where event_name = '$title'";
		$result = $this->db->query($select);
		if($result->count() == 0)
		{
			$query = $this->db->query("insert into ".$this->prefix."events (event_name,event_place,event_description,event_date,start_time,end_time,address,contacts,user_id,contact_email) values ('".$title."','".$place."','".mysql_escape_string($description)."','".$date."','$stime','$etime','$address','$contacts','$userid',$contact_email)");
			if($query)
			{
				echo 'ok';
				$event_id = $query->insert_id();
			        if($event_id)
			        {
			                $queryString =$this->db->query("insert into ".$this->prefix."event_members (event_id,userid,status) values('$event_id','$userid','1')");
		                }
				return 1;
			}
			else
			{
				echo 'error in database';
				return -2;
			}
		}
		else
		{
			return -1;
		}
	}

	public function updateevent($title,$place,$description,$date,$stime,$etime,$address,$contacts,$eid,$contact_email)
	{
	
		if($title != '' && $place != '' && $description != '' && $date != '' && $stime != '' && $etime != '' && $address != '' && $contacts != '')
		{
			$description = mysql_escape_string($description);
			$title = mysql_escape_string($title);
			$address = mysql_escape_string($address);
			$contact_email = mysql_escape_string($contact_email);
			
			$query = "update ".$this->prefix."events set event_name = '$title',event_description = '$description',event_date = '$date',start_time = '$stime',end_time = '$etime',event_place = '$place',address = '$address',contacts = '$contacts',contact_email = '$contact_email' where event_id = '$eid'";
			$result = $this->db->query($query);

			return 1;
		}
		else
		{
			return -1;
		}
	}
	public function delete_event($e_id)
	{
		if($e_id != '')
		{
			$query = "delete from ".$this->prefix."events where event_id = '$e_id'";
			$result = $this->db->query($query);
	          	common::delete_update($eventid,35);
                	common::delete_update($eventid,36);
                	common::delete_update($eventid,38);
			return 1;
		}
		else
		{
			return -1;
		}
	}
	
	public function event_photos($event_id)
	{
	        $query = "select * from ".$this->prefix."event_photo where event_id = '$event_id'";
	        $result = $this->db->query($query);
	        return $result;
	}
	
	//delete event photo
	public function delete_event_photo($photo_id)
	{
		if($photo_id != '')
		{
			$query = "delete from ".$this->prefix."event_photo where photo_id = '$photo_id'";
			$result = $this->db->query($query);
			return 1;
		}
		else
		{
			return -1;
		}
	}
}
?>
