<?php defined('SYSPATH') OR die('No direct access allowed.'); 
/**
 * Google Maps API integration.
 *
 * $Id: Gmap.php 4302 2009-05-01 02:49:41Z kiall $
 *
 * @package    Gmaps
 * @author     Kohana Team
 * @copyright  (c) 2007-2008 Kohana Team
 * @license    http://kohanaphp.com/license.html
 */
class Nauth_Core {

public function __construct()
	{
		parent::__construct();
                $this->docroot = "http://".$_SERVER['HTTP_HOST'].trim($_SERVER['SCRIPT_NAME'],"index.php.");
                $this->users=new Users_Model();
        }

	
        //checking login 
	public function is_login($successurl='',$callbackurl='')
	{
		$session = Session::instance();
		if($session->get('userid')){
			if($successurl){
				url::redirect($successurl);
			}else{
				return TRUE;
			}
		}else{
			if($callbackurl){
			$session->set("Emsg","Login to access this feature");
				url::redirect($callbackurl);
			}else{
				return FALSE;
			}
		}
	}
	
	public function thirdpartylogin($userid='',$username='',$usertype='')
	{
		if($userid && $username && $usertype){
			$session = Session::instance();
			$session->set('userid',$userid);
			$session->set('username',$username);
			$session->set('usertype',$usertype);
			return TRUE; 
		}else{
			return FALSE;
		}
	}
	
	public function setpermission($add='',$edit='',$delete='')
	{
		$this->ADD = $this->EDIT = $this->DELETE = FALSE ;
		if($add){
			$this->ADD = TRUE;
		}
		if($edit){
			$this->EDIT = TRUE;
		}
		if($delete){
			$this->DELETE = TRUE;
		}
		return $this;
	}

	//set the session
	public function setMessage($type='',$msg='')
	{
		
		$session = Session::instance();
		if($type=='1'){
			$session->set('Msg',$msg);
		}elseif($type=='-1')
		{
			$session->set('Emsg',$msg);
		}
	}
	public function print_name($id,$name)
	{
		?>
			<a href="<?php echo $this->docroot ;?>profile/view/?uid=<?php echo $id;?>" title="<?php echo $name;?>"><strong><?php echo ucfirst($name);?></strong></a>
		<?php 
	}
	
 	//GET USER IMAGE 40x40
			
	public function getPhoto($id='',$name='',$photo='')
	{
		$img = "public/user_photo/50/".$id.".jpg";
		if(file_exists($img)){
			$img_path = $this->docroot.$img;
		}
		else{
			$img_url = "http://www.gravatar.com/avatar/".md5($id.$name)."?d=wavatar&s=40"; 
			$img_path = $img_url;
		}  
		?>
        	<a href="<?php echo $this->docroot ;?>profile/view/?uid=<?php echo $id ;?>" class="less_link">
   				 <img src="<?php echo $img_path; ?>" title="<?php echo ucfirst($name);?>" alt="<?php echo $name;?>" width="40" height="40" class="upd_photo" border="0" />  
    		</a>  
       <?php
	}   
	      
	//GET USER IMAGE, NAME 40x40
	
	public function getPhotoName($id='',$name='',$photo='', $isFB = 0, $isTwitter =0)
	{
		$img = "public/user_photo/50/".$id.".jpg";
		if(file_exists($img)){
			$img_path = $this->docroot.$img;
		}
		else{
			$img_url = "http://www.gravatar.com/avatar/".md5($id.$name)."?d=wavatar&s=40"; 
			$img_path = $img_url;
		}  
		?>
        	<a href="<?php echo $this->docroot ;?>profile/view/?uid=<?php echo $id ;?>" class="less_link">
   				 <img src="<?php echo $img_path; ?>" title="<?php echo ucfirst($name);?>" alt="<?php echo $name;?>" class="upd_photo" border="0" />  
    		</a>  
		<br/> 
            <a class="less_link" href="<?php echo $this->docroot;?>profile/view/?uid=<?php echo $id ;?>" title="<?php echo $name; ?>">
            <?php if(strlen($name) > 8)  { echo substr($name,0,7).".."; } else {  echo $name; } ?>
            </a>
	<?php
	}
	
	//get user small image and name with single parameter "id"

	public function getNameImage($user_id='',$name='')
	{ 
		$img = "public/user_photo/50/".$user_id.".jpg";
		if(file_exists($img)){
			$img_path = $this->docroot.$img;
		}
		else{
			$img_url = "http://www.gravatar.com/avatar/".md5($user_id.$name)."?d=wavatar&s=40"; 
			$img_path = $img_url;
		}  
		?>
        	<a href="<?php echo $this->docroot ;?>profile/view/?uid=<?php echo $user_id ;?>" class="less_link">
   		<img src="<?php echo $img_path; ?>" title="<?php echo ucfirst($name);?>" alt="<?php echo $name;?>" class="upd_photo" border="0" />  
    		</a>  
     
    	<a href="<?php echo $this->docroot ;?>profile/view/?uid=<?php echo $user_id; ?>" title="<?php echo $name; ?>" class="less_link">
	<?php  if(strlen($name)>8) {  echo substr(ucfirst($name),0,5)."..."; } else { echo ucfirst($name); } ?>
  	  </a>
	<?php 
	}	
/*	
	
	//user small photo
	public function getPhotoNameHor($id='',$name='',$photo='', $isFB = 0, $isTwitter =0)
	{
	$path="public/user_photo/50/".$this->Name_Image['mysql_fetch_row']->id.".jpg";
		if(file_exists($path)){
	 ?>
				<a class="less_link" href="<?php echo $this->docroot ;?>profile/view/?uid=<?php echo $id ;?>">
				<img   src="<?php echo $this->docroot;?>public/user_photo/50/<?php echo $id;?>.jpg<?php echo end(explode('.',$photo));?>"  alt="<?php echo $name; ?>" title="<?php echo $name; ?>" /></a> 
				<a class="less_link" href="<?php echo $this->docroot ;?>profile/view/<?php echo $id ;?>" title="<?php echo $name; ?>">
				<?php echo $name; ?>
				</a>
                                         
	<?php 
		}
		else{
	?>
				<a class="less_link" href="<?php echo $this->docroot ;?>profile/view/?uid=<?php echo $id ;?>">
				<img   src="<?php echo $this->docroot;?>public/images/no_image.jpg"  alt="<?php echo $name; ?>" title="<?php echo $name; ?>" /></a> 
				<a class="less_link" href="<?php echo $this->docroot ;?>profile/view/<?php echo $id ;?>" title="<?php echo $name; ?>">
				<?php echo $name; ?>
				</a>
		<?php }?>
 	<?php
	}
	
	//user small photo
	public function getSmallPhoto($id='',$name='',$photo='')
	{
	?>

	<img height="40" width="40" src="<?php echo $this->docroot;?>public/user_photo/50/<?php echo $id;?>.<?php echo end(explode('.',$photo));?>"  alt="<?php echo $name; ?>" title="<?php echo $name; ?>" onerror="this.src='<?php echo $this->docroot;?>/public/images/no_image.jpg'";/>
	<?php
	}
*/
//get name alone with single parameter "id"

        public function get_Name($user_id='')
	{
	$this->users=new Users_Model();
	$this->Name_Image=$this->users->nameimage($user_id);  
	if(count($this->Name_Image) > 0)
	{
	?>
    	<a href="<?php echo $this->docroot ;?>profile/view/?uid=<?php if($this->Name_Image){ echo $this->Name_Image['mysql_fetch_row']->id; } else{} ?>" title="<?php if($this->Name_Image){ echo $this->Name_Image['mysql_fetch_row']->name; } else{} ?>" class="less_link">
	<strong><?php if($this->Name_Image) { echo  ucfirst($this->Name_Image["mysql_fetch_row"]->name);  } else{} ?></strong>
  	  </a>
	<?php 
	}
	}
	
	//send the mail
	public function send_mail($to='',$from='',$subject='',$message='',$type='',$objecttype = '')
	{
		
	
		if(!empty($type))
		{
			$this->users=new Users_Model();
			$this->mail_template=$this->users->get_mail_template($type);
			$message=htmlspecialchars_decode($this->mail_template["mysql_fetch_array"]->mail_temp_code);
		}
		
		// To send HTML mail, the Content-type header must be set
		$headers  = 'MIME-Version: 1.0' . "\r\n";
		$headers .= 'Content-type: text/html; charset=iso-8859-1' . "\r\n";
		
		// Additional headers
		$headers .= 'From:'.$from.'' . "\r\n";
		$headers .= 'Cc: '.$from.'' . "\r\n";
		$headers .= 'Bcc: '.$from.'' . "\r\n";

		mail($to, $subject,$message, $headers);
		
	}

	public function send_mail_id($user_id='',$friend_id='',$type='',$description='',$objecttype = '')
	{


		if(!empty($type))
		{
		
	                /* fetch mail template by using $type */	
			$this->users=new Users_Model();
			$this->mail_template=$this->users->get_mail_template($type);
			
	                /* fetch mail subject by using $type */	
			$subject=htmlspecialchars_decode($this->mail_template["mysql_fetch_array"]->mail_subject);			       
			
			/* fetch "to" mail address by using $user_id */	      
			$this->to_mail_id=$this->users->get_mail_addr($user_id);
			if(count($this->to_mail_id)>0)
			{
			        $to=htmlspecialchars_decode($this->to_mail_id["mysql_fetch_array"]->email);
			}
			else
			{
			        $to ="admin@ndot.in";
			}
			
			/* fetch "admin" mail address from db which is "from address" */	      
			$this->from_mail_id=$this->users->get_admin_mail_addr();
			$from=htmlspecialchars_decode($this->from_mail_id["mysql_fetch_array"]->email); 
			
			/*fetch user name */
			$this->user_name=$this->users->get_name($user_id);
			$user_name=$this->user_name["mysql_fetch_array"]->name;

                         /* fetch mail template code by using $type */	
			$message=htmlspecialchars_decode($this->mail_template["mysql_fetch_array"]->mail_temp_code);
                        
                        if($type=='forget password' || $type=='registration' )
                        {
                                
                                /* Replace username, friend name,messsage url,descrip from mail template  */	
			        $message=str_replace('$user_name$',$user_name,$message); 
			        $message=str_replace('$user_id$',$to,$message);
			        $message=str_replace('$user_pass$',$description,$message);
		        }
                        else
                        {
         	                /* fetch "user name and friend name "  by using $user_id  and $friend_id */	      
			        $this->friend_name=$this->users->get_name($friend_id);
			        $friend_name=htmlspecialchars_decode($this->friend_name["mysql_fetch_array"]->name);
			        $friend_name='<a href='.$this->docroot.'profile/view/?uid='.$friend_id.'>'.$friend_name.'</a>';			
			
                                /* Replace username, friend name,messsage url,descrip from mail template  */	
			        $message=str_replace('$user_name$',$user_name,$message); 
			        $message=str_replace('$friend_name$',$friend_name,$message);
			        $message=str_replace('$description$',$description,$message);
                       
                        }
                        
                        // To send HTML mail, the Content-type header must be set
		        $headers  = 'MIME-Version: 1.0' . "\r\n";
		        $headers .= 'Content-type: text/html; charset=iso-8859-1' . "\r\n";
		
		        // Additional headers
		        $headers .= 'From:'.$from.'' . "\r\n";
		        $headers .= 'Cc: '.$from.'' . "\r\n";
		        $headers .= 'Bcc: '.$from.'' . "\r\n";
		       
		        /* send mail function */
		        if(empty($subject))
		        $subject = $type;
		        if($type != 'forget password')
		        {
			        common::insert_mail($user_id,$friend_id,$subject,$message,$objecttype);	
			}
		        @mail($to, $subject,$message, $headers);
		    
		}
	}

        //Function to check module is enable or not
	public function mod_status($mod_name){
	}
}
?>
