<?php
  defined('SYSPATH') or die('No direct script access.');
 /**
 * Defines all photos database activity
 *
 * @package    Core
 * @author     Saranraj
 * @copyright  (c) 2010 Ndot.in
 */

  class Photos_Model extends Model
  {
      public function __construct()
      {
		parent::__construct();
		$this->db = new Database();
		//user response messages
		include Kohana::find_file('../application/config','database',TRUE,'php'); 
		$this->config = $config ['default'];
		$this->prefix = $this->config['table_prefix'];
		$this->usertable = $config['usertable'];
		$mes=Kohana::config('users_config.session_message');
		$this->create_album=$mes["create_album"];
		$this->invalid_photo=$mes["invalid_photo"];
		$this->album_exist=$mes["album_exist"];
		$this->upload_photo=$mes["upload_photo"];
		$this->session = Session::instance();
		$this->user_id=$this->session->get('userid');
		//model object
		$this->update=new update_model_Model();
		$this->session=Session::instance();
		$this->usr_id = $this->session->get('userid');

      }
	  
      //display album
      public function display_album($userid, $offset = '', $pageno = '', $noofpage = '',$friend = 0)
      {
	  	if($userid == $this->user_id){
			$condtiion = "and album_permision in (0,-1,1)";
		}
		elseif($friend > 0){
			$condtiion = "and album_permision in (0,1)";
		}
		else{
			$condtiion = "and album_permision in (0)";
		}
          //having album_permision=0
          $result = $this->db->query("select *,(select count(*) from ".$this->prefix."photos where ".$this->prefix."photos.album_id=".$this->prefix."photos_album.album_id ) as total,album_date from ".$this->prefix."photos_album left join ".$this->prefix.$this->usertable." on ".$this->prefix."photos_album.user_id=".$this->prefix.$this->usertable.".id  having ".$this->prefix."photos_album.user_id='$userid' $condtiion  order by ".$this->prefix."photos_album.album_id desc   limit $offset,$noofpage");
          return $result;
      }
	  
	  //count the  albums
      public function get_count_album($userid,$friend = 0)
      {
	  	  if($userid == $this->user_id){
			$condtiion = "and album_permision in (0,-1,1)";
		}
		elseif($friend > 0){
			$condtiion = "and album_permision in (0,1)";
		}
		else{
			$condtiion = "and album_permision in (0)";
		}
          $result = $this->db->query("select * from ".$this->prefix."photos_album left join ".$this->prefix.$this->usertable." on ".$this->prefix."photos_album.user_id=".$this->prefix.$this->usertable.".id  having ".$this->prefix."photos_album.user_id='$userid' $condtiion order  by ".$this->prefix."photos_album.album_id desc");
          $count_albums = count($result);
          return $count_albums;
      }
	  
      //display  friends album
      public function friends_album($userid, $offset = '', $pageno = '', $noofpage = '')
      {
          //having album_permision=0
          $result = $this->db->query("select *,(select count(*) from ".$this->prefix."photos where ".$this->prefix."photos.album_id= ".$this->prefix."photos_album.album_id ) as total,album_date from ".$this->prefix."photos_album left join ".$this->prefix.$this->usertable." on ".$this->prefix."photos_album.user_id=".$this->prefix.$this->usertable.".id  having ".$this->prefix."photos_album.user_id='$userid' AND ".$this->prefix."photos_album.album_permision=0 order by ".$this->prefix."photos_album.album_id desc   limit $offset,$noofpage");
          return $result;
      }
	  //friends
      public function friends_count_album($userid)
      {
          $result = $this->db->query("select * from ".$this->prefix."photos_album left join ".$this->prefix.$this->usertable." on ".$this->prefix."photos_album.user_id=".$this->prefix.$this->usertable.".id  having ".$this->prefix."photos_album.user_id='$userid' AND ".$this->prefix."photos_album.album_permision=0  order  by ".$this->prefix."photos_album.album_id desc");
          $count_albums = count($result);
          return $count_albums;
      }
	  
     
	  //get the albums photo lists
      public function get_view_album($album_id)
      {
          $result = $this->db->query("select * from ".$this->prefix."photos_album where album_id='$album_id'");
          $count_vp = count($result);
          return $count_vp;
      }
	 
      
	 
      /* to get album photo to show in updates */
	  public function get_abmphoto($album_id)
      {
          $result = $this->db->query("select photo_name,photo_title,photo_id from ".$this->prefix."photos where album_id='$album_id' order by photo_id desc ");
          return $result;  
      }      
      
	  //delete the photo comments
      public function delete_photocomment($comment_id)
      {
          	$check_user=$this->db->query("SELECT user_id from ".$this->prefix."photo_comment where comment_id='$comment_id'");
	        if($check_user["mysql_fetch_array"]->user_id == $this->user_id) 
	        {
                $result = $this->db->query("delete from ".$this->prefix."photo_comment where comment_id='$comment_id'");
          	  return 1;
          	}
          	else
          	{
          	return 0;
          	}
          
      }
	  
      //delete album
      public function delete_album($album_id)
      {
         
          	$check_user=$this->db->query("SELECT user_id from ".$this->prefix."photos_album where album_id='$album_id'");
	        if($check_user["mysql_fetch_array"]->user_id == $this->user_id) 
	        {
                  $result = $this->db->query("delete from ".$this->prefix."photos_album where album_id='$album_id'");
                  common::delete_update($album_id , 22 ); 
                  common::delete_update($album_id , 24 ); 
                 $photo_id = $this->db->query("SELECT photo_id FROM ".$this->prefix."photos where album_id = '$album_id' ");
                 foreach($photo_id as $r)
                 {
                 common::delete_update( $r->photo_id, 25 ); 
                 }
          	  return 1;
          	}
          	else
          	{
          	return 0;
          	}
          
          
      }
	  
      //edit album
      public function edit_album($album_id, $edit_title, $edit_description)
      {
	$edit_title = html::specialchars($edit_title);
	$edit_description = html::specialchars($edit_description);
	$result = $this->db->query("update ".$this->prefix."photos_album set album_title='$edit_title',album_desc='$edit_description' where album_id='$album_id'");
	$this->update->updates_insert($this->usr_id,$album_id,24,'',$edit_title);
	return $result;
      }
	  
      //album cover
      public function album_cover($album_id, $album_cover)
      {
          $result = $this->db->query("update ".$this->prefix."photos_album set album_cover='$album_cover' where album_id='$album_id'");
          return $result;
      }
     	
      public function album_photo($album_id)
      {
          $result = $this->db->query("select photo_id from ".$this->prefix."photos where album_id='$album_id' limit 0,1");
          return $result;
      }
	  
      //full photo
      public function full_photo($photo_id, $album_id)
      {
          $result = $this->db->query("select * from ".$this->prefix."photos where photo_id='$photo_id' AND album_id='$album_id' ");
          return $result;
      }
	  
      public function get_count_fullshow($photo_id, $album_id)
      {
          $result = $this->db->query("select * from ".$this->prefix."photos where photo_id='$photo_id' AND album_id='$album_id'");
          $count_full = count($result);
          return $count_full;
      }
	  
      //photo comment
		public function photo_comment($photo_id, $photo_text, $userid)
		{
			$photo_text = html::specialchars($photo_text);
		
			if ($photo_text != "") {
				$this->db->query("update ".$this->prefix."photos set count_comment=count_comment+1 where photo_id='$photo_id'");
				$result = $this->db->query("insert into ".$this->prefix."photo_comment(photo_id,user_id,comments,photo_date) values ('$photo_id','$userid','$photo_text',sysdate())");
				$post_id = $result->insert_id();
				$result1=$this->db->query("select photo_title from ".$this->prefix."photos where photo_id='$photo_id'");
				$phototitle=htmlspecialchars_decode($result1["mysql_fetch_object"]->photo_title); 
				$this->update->updates_insert($userid,$photo_id,25,'',$phototitle,$post_id);
				return $result;
			}
			 else {
			}
		}
      //show photo
      public function show_comment($photo_id)
      {
          $result = $this->db->query("select *,photo_date from ".$this->prefix."photo_comment left join ".$this->prefix.$this->usertable." on ".$this->prefix."photo_comment.user_id=".$this->prefix.$this->usertable.".id left join ".$this->prefix."users_profile on ".$this->prefix.$this->usertable.".id=".$this->prefix."users_profile.user_id having ".$this->prefix."photo_comment.photo_id='$photo_id' ");
          return $result;
      }
	  
                //delete photo
		public function delete_photo($photo_id= '',$userid = '')
		{
	                $get_albm_id = $this->db->query("SELECT album_id from ".$this->prefix."photos where photo_id='$photo_id'");
	                $albm_id = $get_albm_id['mysql_fetch_object']->album_id; 
	                $get_photo_count = $this->db->query("SELECT id,photo_count from ".$this->prefix."updates where type_id='$albm_id' and action_id =22");
	                $upd_id =  $get_photo_count['mysql_fetch_object']->id; 
	                if($get_photo_count['mysql_fetch_object']->photo_count > 1)
	                {
	                $upd_update = $this->db->query("UPDATE ".$this->prefix."updates SET `photo_count` = photo_count-1  WHERE `id` = '$upd_id' ");                		               
	                }
	                else
	                {
			$del_upd = $this->db->delete("updates", array("id" => $upd_id));	                
	                }
       	                $del_photo_cmd = $this->db->query("select comment_id from  ".$this->prefix."photo_comment where photo_id='$photo_id'");
       	                
                      foreach($del_photo_cmd as $r)
       	                { 
       	                common::delete_update($photo_id,25,$r->comment_id);
       	                } 
			$result = $this->db->delete("photos", array("photo_id" => $photo_id, "user_id" => $userid));
			return $result;
		}
	  
      //edit photo
      public function edit_photo($photo_id, $photo_title)
      {
          $photo_title = html::specialchars($photo_title);
          $result = $this->db->query("update ".$this->prefix."photos set photo_title='$photo_title' where photo_id='$photo_id'");
          return $result;
      }

	
	/**  CREATE NEW ALBUM  **/
	
	public function createalbum($userid, $title, $desc, $share)
	{
		 $unique = $this->db->count_records("photos_album", array("user_id" => $userid, "album_title" => $title));
		 if($unique == 0){
		 	if(trim($title)){
				$title = html::specialchars($title);
				$desc = html::specialchars($desc);
				$result = $this->db->query("insert into ".$this->prefix."photos_album(user_id,album_title,album_desc,album_date,album_permision) VALUES( '$userid','$title','$desc',SYSDATE(),'$share')");

				Nauth::setMessage(1,$this->create_album);
			}
			else{
				Nauth::setMessage(-1,"Invalid  Album Title");
			}
		 }
		 else{
		 	Nauth::setMessage(-1,$this->album_exist);
		 }
	}
	 
	/** COUNT PHOTOS IN PERTICULAR ALBUM **/
	 
	public function get_count_show($album_id = "" )
	{
		$result = $this->db->count_records("photos", array("album_id" => $album_id, "object_type" => 1)); 
		return $result;
	} 
	 
	/** LIST PERTICULAR ALBUM PHOTO **/
	
	public function show_photo($album_id, $offset = '', $pageno = '', $noofpage = '')
	{	  
		$album_photo = $this->db->from("photos")
								->where(array("album_id" => $album_id, "object_type" => 1 ))
								->orderby("photo_id" , "DESC")
								->limit($noofpage,$offset)
								->get();
		return $album_photo;
	}
	  
	/** CHECK ALBUM EXIST OR NOT **/
	  
	public function view_albumphoto($album_id)
	{ 
		$result = $this->db->from("photos_album")->where(array("album_id" => $album_id))->get();
		return $result;
	}
	  
	  /**  UPLOAD ALBUM PHOTO **/
	  
	public function insert_photo($userid = "", $album_id = "", $upload_title = "", $photo_name = "")
	{
		
		$_FILES = Validation::factory($_FILES)->add_rules('upload_photo[]', 'upload::valid', 'upload::type[gif,jpg,png,JPG]', 'upload::size[1M]');
		if($_FILES->validate()){  
			$i=0;
			foreach( arr::rotate($_FILES['upload_photo']) as $file )
			{                 
				$upload_title[$i] = html::specialchars($upload_title[$i]);
				$photo_name[$i] = html::specialchars($photo_name[$i]);
          		$result = $this->db->query("insert into ".$this->prefix."photos(album_id,user_id,photo_title,photo_date)values('$album_id','$userid','$upload_title[$i]',sysdate())");
			
				if(count($result) > 0){
					$photoid=$result->insert_id();
					$id = $result->insert_id();
					$filename = upload::save($file);
	
					$exact_file_name=end(explode("/",$filename));
					$userDoc = DOCROOT."upload/$exact_file_name";
					
					$userDoc = str_replace("'", "", $userDoc);
					list($width, $height) = getimagesize($userDoc);
					if($filename){
						
						$size_adj = photo_size::size($width, $height,50,50);
						extract($size_adj);
						Image::factory($filename)
							->resize($width_adj,$height_adj, Image::NONE)->crop(50, 50, 'top')
							->save(DOCROOT . '/public/album_photo/50/' . $id .'.jpg');
							
						$size_adj = photo_size::size($width, $height,100,100);
						extract($size_adj);
						Image::factory($filename)
							->resize($width_adj,$height_adj, Image::NONE)->crop(100, 100, 'top')
							->save(DOCROOT . '/public/album_photo/' . $id . '.jpg');
			
							if ($width < 600 ){
								Image::factory($filename)->save(DOCROOT . '/public/album_photo/normal/' . $id . '.' . $file_path . '');
							} 
							else{
								Image::factory($filename)->resize(600, 600, Image::WIDTH)->save(DOCROOT . '/public/album_photo/normal/' . $id . '.jpg');
							}
						unlink($filename);
					}
  					Nauth::setMessage(1,$this->upload_photo);
					$i++;
				}
	        }

	        //for updates 
			$check_upd = $this->db->query("select id from ".$this->prefix."updates where type_id = '$album_id' and action_id = '22' ");
			if(count($check_upd)){ 
			$check_upd_date = $this->db->query("select id from ".$this->prefix."updates where type_id = '$album_id' and action_id = '22' and trim(DATE(date)) = CURDATE() ");			
			        if(count($check_upd_date))
                		{
			$upd_id = $check_upd_date['mysql_fetch_object']->id; 
			$upd_update = $this->db->query("UPDATE ".$this->prefix."updates SET `photo_count` = photo_count + '$i' , date = now() WHERE `id` = '$upd_id' ");                		               
                		}
                		else
                		{
			$upd_id = $check_upd['mysql_fetch_object']->id; 
			$upd_update = $this->db->query("UPDATE ".$this->prefix."updates SET `photo_count` = '$i' , date = now() WHERE `id` = '$upd_id' ");
			        }
			}
			else{ 
				$albm_title = $this->db->query("select album_title from ".$this->prefix."photos_album where album_id = '$album_id' ");
				$album_title = $albm_title["mysql_fetch_object"]->album_title; 
				$this->update->updates_insert($userid,$album_id,22,'',$album_title,'',$i);			
			} 
          } 
	  else{ 
		Nauth::setMessage(1,$this->invalid_photo);
	  }
	}
 
 	 //search album
      public function search_album($key,$userid, $offset = '', $pageno = '', $noofpage = '')
      {
          //having album_permision=0
          $result = $this->db->query("select *,(select count(*) from ".$this->prefix."photos where ".$this->prefix."photos.album_id=".$this->prefix."photos_album.album_id ) as total,album_date from ".$this->prefix."photos_album left join ".$this->prefix.$this->usertable." on ".$this->prefix."photos_album.user_id=".$this->prefix.$this->usertable.".id  having ".$this->prefix."photos_album.user_id='$userid' AND ".$this->prefix."photos_album.album_title like '%$key%' order by ".$this->prefix."photos_album.album_id desc   limit $offset,$noofpage");
          return $result;
      }
      public function search_album_count($key,$userid)
      {
          //having album_permision=0
          $result = $this->db->query("select *,(select count(*) from ".$this->prefix."photos where ".$this->prefix."photos.album_id=".$this->prefix."photos_album.album_id ) as total,album_date from ".$this->prefix."photos_album left join ".$this->prefix.$this->usertable." on ".$this->prefix."photos_album.user_id=".$this->prefix.$this->usertable.".id  having ".$this->prefix."photos_album.user_id='$userid' AND ".$this->prefix."photos_album.album_title like '%$key%' order by ".$this->prefix."photos_album.album_id desc");
         
          return count($result);
      }
        //delete photo comment
        public function delete_photo_comment($cid,$pid)
        {
                $this->db->query("update ".$this->prefix."photos set count_comment=count_comment-1 where photo_id='$pid'");
                $result = $this->db->query( "delete from ".$this->prefix."photo_comment where comment_id='$cid' ");
                return $result;
        }
		
  }

?>
