<?php
class Register_Model extends Model
{
	public function __construct()
	{
		include Kohana::find_file('/config/','database',TRUE,'php');
		$this->config = $config ['default'];
		$this->prefix = $this->config['table_prefix'];
		$this->usertable = $config['usertable'];
		$this->uidfield = $config['uidfield'];
		$this->unamefield = $config['unamefield'];
		$this->upass = $config['upass'];
		$this->uemail = $config['uemail'];
		$this->ustatus = $config['ustatus'];
		$this->utype = $config['utype'];
		$this->tempath = $config['tempath'];

	   parent::__construct();
	   $db=new Database();
	   $this->controller = new Confirm_Controller();
	   
	}

	//Get user's details
	public function getusers()
	{
		$query = "select * from ".$this->prefix.$this->usertable." left join ".$this->prefix."users_profile on id=user_id  where user_type = '1'";
		$result = $this->db->query($query);
		return $result;
	}
 
	//getting existing user
	
	public function existuser($email)
	{
		$query = "select email from ".$this->prefix.$this->usertable." where email = '$email'";
		$result = $this->db->query($query);
		return $result;
	}
	
	//Add new Users
	
	public function adduser($f_name,$email,$password)
	{
		if($f_name !='' && $email !='' && $password !='')
		{
			$pass = md5($password);
			$insert_query = "insert into ".$this->prefix.$this->usertable."(name,email,password,user_type,user_status) values('$f_name','$email','$pass','1','1')";
			$insert_exec = $this->db->query($insert_query);
			$last_id=$insert_exec->insert_id();
			
			/*Insert into user profile table*/
			$insert_query_1 = "insert into ".$this->prefix."users_profile(user_id) values('$last_id')";
			$insert_exec_1 = $this->db->query($insert_query_1);
			
			/*Insert into profile settings table*/
			$insert_query_2 = "insert into ".$this->prefix."profile_settings(user_id) values('$last_id')";
			$insert_exec_2 = $this->db->query($insert_query_2);
			$insert_query_3 = "insert into ".$this->prefix."module_settings(user_id) values('$last_id')";
           		$insert_exec_3 = $this->db->query($insert_query_3);
			$to = $email;
			$subject = 'Registration Details';
			$message = '
			<p><strong>Dear&nbsp;&nbsp;'.$f_name.'</strong></p>
			<p>Your Registration completed successfully. Your registration details are below</p>
			<p><strong>Username&nbsp;:</strong>'.$email.'</p>
			<p><strong>Password&nbsp;:</strong>'.$password.'</p>
			<p>Regards</p>
			<p>Sawaal Team.</p>
			';
			// To send HTML mail, the Content-type header must be set
		        $headers  = 'MIME-Version: 1.0' . "\r\n";
		        $headers .= 'Content-type: text/html; charset=iso-8859-1' . "\r\n";
		
		        // Additional headers
		        $headers .= 'From: admin@ndot.in' . "\r\n";
		        $headers .= 'Cc: admin@ndot.in' . "\r\n";
		        $headers .= 'Bcc: admin@ndot.in' . "\r\n";
		
			mail($to,$subject,$message,$headers);
			//$this->controller->confirm_email($last_id,$subject,$message,1,'');
			return $last_id;
		}
		else
		{
			$this->session->set('Msg','Some Fields are Missing');
		}
	}
	
	//getting users for edit details
	public function editusers($user_id)
	{
		$select = "select * from ".$this->prefix.$this->usertable." where ".$this->prefix.$this->usertable.".id = '$user_id'";
		$result = $this->db->query($select);
		return $result;
	}
	
	
	//updating user details
	public function updateuser($f_name,$l_name,$email,$dob,$gender,$street,$city,$country,$code,$phone,$mobile,$news,$user_status,$user_id)
	{
		$update = "UPDATE ".$this->prefix.$this->usertable." SET name = '$f_name',last_name = '$l_name',email = '$email',street = '$street',city = '$city',country = '$country',post_code = '$code',phone = '$phone',mobile = '$mobile',news_letter = '$news',dob = '$dob',user_status = '$user_status' , gender = '$gender' WHERE user_id = '$user_id'";
		$result = $this->db->query($update);
		return $result;
	}
	
	//users profile
	
	public function profile($userid)
	{
		if($userid)
		{
			$select = "select * from ".$this->prefix.$this->usertable." left join ".$this->prefix."country on ".$this->prefix.$this->usertable.".country = ".$this->prefix."country.id where ".$this->prefix.$this->usertable.".id = '$userid'";
			$result = $this->db->query($select);
			return $result;
		}
		else
		{
			$this->session->set('Msg','Invalid Operation.');
			return -1;
		}
	}
	
	//user settings for changing password
	
	public function settings($userid,$old_pass,$new_pass)
	{
		if($userid)
		{
			$pass = md5($old_pass);
			$new = md5($new_pass);
			$select = "select * from ".$this->prefix.$this->usertable." where password = '$pass' and ".$this->prefix.$this->usertable.".id = '$userid'";
			$result = $this->db->query($select);
			if($result->count() > 0)
			{
				$update = "update ".$this->prefix.$this->usertable." set password = '$new' where ".$this->prefix.$this->usertable.".id = '$userid'";
				$update_result = $this->db->query($update);
				return 1;
			}
			else
			{
				return -2;
			}
		}
		else
		{
			return -1;
		}
	}
	//delete users
	public function deleteuser($userid)
	{
		$delete = "delete from ".$this->prefix.$this->usertable." where ".$this->prefix.$this->usertable.".id = '$userid'";
		$result = $this->db->query($delete);
		return $result;
	}
 
	 
}
?>
